# coding: utf-8

"""
    Speech Services API v2.0

    Speech Services API v2.0.  # noqa: E501

    OpenAPI spec version: v2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class DatasetDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'data_import_kind': 'str',
        'name': 'str',
        'description': 'str',
        'properties': 'dict(str, str)',
        'locale': 'str'
    }

    attribute_map = {
        'data_import_kind': 'dataImportKind',
        'name': 'name',
        'description': 'description',
        'properties': 'properties',
        'locale': 'locale'
    }

    def __init__(self, data_import_kind=None, name=None, description=None, properties=None, locale=None):  # noqa: E501
        """DatasetDefinition - a model defined in Swagger"""  # noqa: E501

        self._data_import_kind = None
        self._name = None
        self._description = None
        self._properties = None
        self._locale = None
        self.discriminator = None

        self.data_import_kind = data_import_kind
        self.name = name
        if description is not None:
            self.description = description
        if properties is not None:
            self.properties = properties
        self.locale = locale

    @property
    def data_import_kind(self):
        """Gets the data_import_kind of this DatasetDefinition.  # noqa: E501

        The kind of the dataset (e.g. acoustic data, language data ...)  # noqa: E501

        :return: The data_import_kind of this DatasetDefinition.  # noqa: E501
        :rtype: str
        """
        return self._data_import_kind

    @data_import_kind.setter
    def data_import_kind(self, data_import_kind):
        """Sets the data_import_kind of this DatasetDefinition.

        The kind of the dataset (e.g. acoustic data, language data ...)  # noqa: E501

        :param data_import_kind: The data_import_kind of this DatasetDefinition.  # noqa: E501
        :type: str
        """
        if data_import_kind is None:
            raise ValueError("Invalid value for `data_import_kind`, must not be `None`")  # noqa: E501
        allowed_values = ["Acoustic", "Language", "Pronunciation", "None", "CustomVoice", "AudioFiles", "KeywordAudioTranscript"]  # noqa: E501
        if data_import_kind not in allowed_values:
            raise ValueError(
                "Invalid value for `data_import_kind` ({0}), must be one of {1}"  # noqa: E501
                .format(data_import_kind, allowed_values)
            )

        self._data_import_kind = data_import_kind

    @property
    def name(self):
        """Gets the name of this DatasetDefinition.  # noqa: E501

        The name of the object  # noqa: E501

        :return: The name of this DatasetDefinition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this DatasetDefinition.

        The name of the object  # noqa: E501

        :param name: The name of this DatasetDefinition.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def description(self):
        """Gets the description of this DatasetDefinition.  # noqa: E501

        The description of the object  # noqa: E501

        :return: The description of this DatasetDefinition.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this DatasetDefinition.

        The description of the object  # noqa: E501

        :param description: The description of this DatasetDefinition.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def properties(self):
        """Gets the properties of this DatasetDefinition.  # noqa: E501

        The custom properties of this entity  # noqa: E501

        :return: The properties of this DatasetDefinition.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this DatasetDefinition.

        The custom properties of this entity  # noqa: E501

        :param properties: The properties of this DatasetDefinition.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def locale(self):
        """Gets the locale of this DatasetDefinition.  # noqa: E501

        The locale of the contained data  # noqa: E501

        :return: The locale of this DatasetDefinition.  # noqa: E501
        :rtype: str
        """
        return self._locale

    @locale.setter
    def locale(self, locale):
        """Sets the locale of this DatasetDefinition.

        The locale of the contained data  # noqa: E501

        :param locale: The locale of this DatasetDefinition.  # noqa: E501
        :type: str
        """
        if locale is None:
            raise ValueError("Invalid value for `locale`, must not be `None`")  # noqa: E501

        self._locale = locale

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(DatasetDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DatasetDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
