# coding: utf-8

"""
    Speech Services API v2.0

    Speech Services API v2.0.  # noqa: E501

    OpenAPI spec version: v2.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six


class EndpointDefinition(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'concurrent_recognitions': 'int',
        'content_logging_enabled': 'bool',
        'models': 'list[ModelIdentity]',
        'description': 'str',
        'locale': 'str',
        'properties': 'dict(str, str)',
        'name': 'str'
    }

    attribute_map = {
        'concurrent_recognitions': 'concurrentRecognitions',
        'content_logging_enabled': 'contentLoggingEnabled',
        'models': 'models',
        'description': 'description',
        'locale': 'locale',
        'properties': 'properties',
        'name': 'name'
    }

    def __init__(self, concurrent_recognitions=None, content_logging_enabled=None, models=None, description=None, locale=None, properties=None, name=None):  # noqa: E501
        """EndpointDefinition - a model defined in Swagger"""  # noqa: E501

        self._concurrent_recognitions = None
        self._content_logging_enabled = None
        self._models = None
        self._description = None
        self._locale = None
        self._properties = None
        self._name = None
        self.discriminator = None

        if concurrent_recognitions is not None:
            self.concurrent_recognitions = concurrent_recognitions
        if content_logging_enabled is not None:
            self.content_logging_enabled = content_logging_enabled
        self.models = models
        if description is not None:
            self.description = description
        self.locale = locale
        if properties is not None:
            self.properties = properties
        self.name = name

    @property
    def concurrent_recognitions(self):
        """Gets the concurrent_recognitions of this EndpointDefinition.  # noqa: E501

        The number of concurrent recognitions the endpoint supports  # noqa: E501

        :return: The concurrent_recognitions of this EndpointDefinition.  # noqa: E501
        :rtype: int
        """
        return self._concurrent_recognitions

    @concurrent_recognitions.setter
    def concurrent_recognitions(self, concurrent_recognitions):
        """Sets the concurrent_recognitions of this EndpointDefinition.

        The number of concurrent recognitions the endpoint supports  # noqa: E501

        :param concurrent_recognitions: The concurrent_recognitions of this EndpointDefinition.  # noqa: E501
        :type: int
        """
        if concurrent_recognitions is not None and concurrent_recognitions > 20:  # noqa: E501
            raise ValueError("Invalid value for `concurrent_recognitions`, must be a value less than or equal to `20`")  # noqa: E501
        if concurrent_recognitions is not None and concurrent_recognitions < 1:  # noqa: E501
            raise ValueError("Invalid value for `concurrent_recognitions`, must be a value greater than or equal to `1`")  # noqa: E501

        self._concurrent_recognitions = concurrent_recognitions

    @property
    def content_logging_enabled(self):
        """Gets the content_logging_enabled of this EndpointDefinition.  # noqa: E501

        A value indicating whether content logging (audio &amp; transcriptions) is being used for a deployment  # noqa: E501

        :return: The content_logging_enabled of this EndpointDefinition.  # noqa: E501
        :rtype: bool
        """
        return self._content_logging_enabled

    @content_logging_enabled.setter
    def content_logging_enabled(self, content_logging_enabled):
        """Sets the content_logging_enabled of this EndpointDefinition.

        A value indicating whether content logging (audio &amp; transcriptions) is being used for a deployment  # noqa: E501

        :param content_logging_enabled: The content_logging_enabled of this EndpointDefinition.  # noqa: E501
        :type: bool
        """

        self._content_logging_enabled = content_logging_enabled

    @property
    def models(self):
        """Gets the models of this EndpointDefinition.  # noqa: E501

        Information about the deployed models  # noqa: E501

        :return: The models of this EndpointDefinition.  # noqa: E501
        :rtype: list[ModelIdentity]
        """
        return self._models

    @models.setter
    def models(self, models):
        """Sets the models of this EndpointDefinition.

        Information about the deployed models  # noqa: E501

        :param models: The models of this EndpointDefinition.  # noqa: E501
        :type: list[ModelIdentity]
        """
        if models is None:
            raise ValueError("Invalid value for `models`, must not be `None`")  # noqa: E501

        self._models = models

    @property
    def description(self):
        """Gets the description of this EndpointDefinition.  # noqa: E501

        The description of the object  # noqa: E501

        :return: The description of this EndpointDefinition.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this EndpointDefinition.

        The description of the object  # noqa: E501

        :param description: The description of this EndpointDefinition.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def locale(self):
        """Gets the locale of this EndpointDefinition.  # noqa: E501

        The locale of the contained data  # noqa: E501

        :return: The locale of this EndpointDefinition.  # noqa: E501
        :rtype: str
        """
        return self._locale

    @locale.setter
    def locale(self, locale):
        """Sets the locale of this EndpointDefinition.

        The locale of the contained data  # noqa: E501

        :param locale: The locale of this EndpointDefinition.  # noqa: E501
        :type: str
        """
        if locale is None:
            raise ValueError("Invalid value for `locale`, must not be `None`")  # noqa: E501

        self._locale = locale

    @property
    def properties(self):
        """Gets the properties of this EndpointDefinition.  # noqa: E501

        The custom properties of this entity  # noqa: E501

        :return: The properties of this EndpointDefinition.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this EndpointDefinition.

        The custom properties of this entity  # noqa: E501

        :param properties: The properties of this EndpointDefinition.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def name(self):
        """Gets the name of this EndpointDefinition.  # noqa: E501

        The name of the object  # noqa: E501

        :return: The name of this EndpointDefinition.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this EndpointDefinition.

        The name of the object  # noqa: E501

        :param name: The name of this EndpointDefinition.  # noqa: E501
        :type: str
        """
        if name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(EndpointDefinition, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, EndpointDefinition):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
